    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * -------------------
    028 * XYURLGenerator.java
    029 * -------------------
    030 * (C) Copyright 2002-2008, by Richard Atkinson and Contributors.
    031 *
    032 * Original Author:  Richard Atkinson;
    033 * Contributors:     David Gilbert (for Object Refinery Limited);
    034 *
    035 * Changes:
    036 * --------
    037 * 05-Aug-2002 : Version 1, contributed by Richard Atkinson;
    038 * 09-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    039 * 20-Jan-2005 : Minor Javadoc update (DG);
    040 * ------------- JFREECHART 1.0.x ---------------------------------------------
    041 * 02-Feb-2007 : Removed author tags from all over JFreeChart sources (DG);
    042 * 13-Dec-2007 : Updated API docs (DG);
    043 *
    044 */
    045
    046package org.jfree.chart.urls;
    047
    048import org.jfree.data.xy.XYDataset;
    049
    050/**
    051 * Interface for a URL generator for plots that uses data from an
    052 * {@link XYDataset}.  Classes that implement this interface are responsible
    053 * for correctly escaping any text that is derived from the dataset, as this
    054 * may be user-specified and could pose a security risk.
    055 */
    056public interface XYURLGenerator {
    057
    058    /**
    059     * Generates a URL for a particular item within a series. As a guideline,
    060     * the URL should be valid within the context of an XHTML 1.0 document.
    061     *
    062     * @param dataset  the dataset (<code>null</code> not permitted).
    063     * @param series  the series index (zero-based).
    064     * @param item  the item index (zero-based).
    065     *
    066     * @return A string containing the generated URL (possibly
    067     *         <code>null</code>).
    068     */
    069    public String generateURL(XYDataset dataset, int series, int item);
    070
    071}